SHELL	= /bin/sh

#ifdef _AIX
CC	= cc -qlanglvl=ansi
#endif

CFLAGS	= 

OBJS    = driver.o tdcore.o SourceNode.o glahead.o attrmain.o \
	visitprocs.o treecon.o db.o deftbl.o dbgen.o dbdefs.o ptg_gen.o \
	ptgtypes.o ptgstr.o Ccomment.o auxScanEOL.o envmod.o dfltclp.o source.o \
	err.o csm.o idn.o str.o

ptg.exe:	$(OBJS)
	$(CC) -o ptg.exe $(CFLAGS) $(OBJS)

clean:
	rm -f a.out *.o *.a core ERRS ptg.exe

tidy:
	rm -f core a.out *.o *~ *.a ERRS

driver.o:       driver.c HEAD.h INIT.h FINL.h db.h ptg_gen.h envmod.h \
ptgtypes.h csm.h err.h envmod.h 
tdcore.o:       tdcore.c ptabs.h tdframe.h parser.h semprods.h err.h 
SourceNode.o:   SourceNode.c err.h treecon.h 
glahead.o:      glahead.c err.h source.h xtables.h xcode.h 
attrmain.o:     attrmain.c HEAD.h node.h treecon.h visitprocs.h db.h \
ptg_gen.h envmod.h ptgtypes.h csm.h err.h envmod.h err.h 
visitprocs.o:   visitprocs.c HEAD.h err.h node.h treecon.h visitprocs.h \
glattr.h attrpredef.h db.h ptg_gen.h envmod.h ptgtypes.h csm.h err.h \
envmod.h err.h 
treecon.o:      treecon.c HEAD.h err.h node.h visitprocs.h treecon.h \
gsdescr.h db.h ptg_gen.h envmod.h ptgtypes.h csm.h err.h envmod.h err.h 
db.o:   db.c dbconst.h dbtypes.h dbgen.h 
deftbl.o:       deftbl.c dbtypes.h dbgen.h dbconst.h 
dbgen.o:        dbgen.c err.h dbtypes.h 
dbdefs.o:       dbdefs.c dbtypes.h 
ptg_gen.o:      ptg_gen.c ptg_gen.h 
ptgtypes.o:     ptgtypes.c ptg_gen.h ptgtypes.h 
ptgstr.o:       ptgstr.c err.h source.h gla.h 
Ccomment.o:     Ccomment.c err.h gla.h source.h 
auxScanEOL.o:   auxScanEOL.c err.h gla.h source.h 
envmod.o:       envmod.c err.h envmod.h 
dfltclp.o:      dfltclp.c source.h 
source.o:       source.c source.h 
err.o:  err.c err.h source.h 
csm.o:  csm.c csm.h err.h csmtbl.h 
idn.o:  idn.c err.h idn.h csm.h idntbl.h 
str.o:  str.c str.h csm.h 
